<template>
  <div>
    <icon @goto="handleGoto" />
  </div>
</template>

<script setup lang="ts">
import { computed, h } from 'vue'
import { Modal } from '@arco-design/web-vue'
import TableBtnItem from './item.vue'
import { DEFAULT_VALUE, ILocale, IShape, IType } from './help'
import { useLocale } from '@arco-vue-x/utils'
import { en, zhCN, zhTW, ru } from './lang'

const { locale } = useLocale<ILocale>({ en, zhCN, zhTW, ru })

const emits = defineEmits(['click'])

const props = withDefaults(defineProps<{
  outsize?: number;
  content?: string;
  type: IType;
  size?: number;
  confirm?: 1 | 0;
  confirmContent?: string;
  disabled?: boolean;
  loading?: boolean;
  shape?: IShape;
  btnType?: 'primary' | 'secondary' | 'dashed' | 'outline' | 'text';
  status?: 'normal' | 'success' | 'warning' | 'danger' | undefined;
  position?:
    | 'top'
    | 'tl'
    | 'tr'
    | 'bottom'
    | 'bl'
    | 'br'
    | 'left'
    | 'lt'
    | 'lb'
    | 'right'
    | 'rt'
    | 'rb';
}>(), {
  shape: DEFAULT_VALUE.shape,
  btnType: 'primary',
  outsize: 32
})

const realSize = computed(
  () => props.size || (props.shape === 'square' ? 18 : 16)
)

const { isBold } = DEFAULT_VALUE

const tooltip = computed(() => props.content || locale.value[props.type] || '')

const confirmContentTxt = computed(
  () =>
    props.confirmContent ??
    (props.type === 'delete' ? locale.value.confirmDel : tooltip.value)
)

const needConfirm = computed(() => {
  if (props.confirm === 0) {
    return false
  }
  return props.confirmContent || props.confirm === 1 || props.type === 'delete'
})

const icon = () => {
  const {
    disabled,
    loading,
    type,
    shape,
    content,
    btnType,
    status,
    outsize,
    position
  } = props
  return h(TableBtnItem, {
    disabled,
    tooltip: tooltip.value,
    size: realSize.value,
    loading,
    type,
    shape,
    content,
    isBold,
    btnType,
    status,
    outsize,
    position
  })
}

const handleGoto = () => {
  if (needConfirm.value) {
    Modal.confirm({
      simple: false,
      width: '20%',
      title: locale.value.tips,
      content: confirmContentTxt.value,
      hideCancel: false,
      escToClose: false,
      titleAlign: 'start',
      okText: locale.value.confirm,
      cancelText: locale.value.cancel,
      onOk: () => {
        emits('click')
      }
    })
  } else {
    emits('click')
  }
}
</script>

<style lang="less" scoped>
.templateIcon {
  stroke-width: 5;
  &.f18 {
    font-size: 18px;
  }
}
</style>
